Index: /cpp/frams/Makefile-SDK-files
===================================================================
--- /cpp/frams/Makefile-SDK-files	(revision 1043)
+++ /cpp/frams/Makefile-SDK-files	(revision 1044)
@@ -2,5 +2,5 @@
 
 # ALL_DIRS is later expanded by the shell, no spaces/newlines allowed, or it breaks
-ALL_DIRS={common,PrintFloat,frams,frams/canvas,frams/config,common/loggers,frams/genetics,frams/genetics/f0,frams/genetics/f1,frams/genetics/f2,frams/genetics/f3,frams/genetics/f4,frams/genetics/f5,frams/genetics/f6,frams/genetics/f7,frams/genetics/f8,frams/genetics/f9,frams/genetics/fn,frams/genetics/fF,frams/genetics/fT,frams/genetics/fB,frams/genetics/fH,frams/genetics/fL,frams/genetics/fS,frams/model,frams/neuro,frams/neuro/impl,frams/param,frams/test,frams/util,frams/vm/classes,common/virtfile,frams/_demos,frams/model/geometry,frams/_demos/geometry,frams/model/similarity,frams/model/similarity/hungarian,frams/model/similarity/SVD}
+ALL_DIRS={common,PrintFloat,frams,frams/canvas,frams/config,common/loggers,frams/genetics,frams/genetics/f0,frams/genetics/f1,frams/genetics/f2,frams/genetics/f3,frams/genetics/f4,frams/genetics/f5,frams/genetics/f6,frams/genetics/f7,frams/genetics/f8,frams/genetics/f9,frams/genetics/fn,frams/genetics/fF,frams/genetics/fT,frams/genetics/fB,frams/genetics/fH,frams/genetics/fL,frams/genetics/fS,frams/model,frams/neuro,frams/neuro/impl,frams/param,frams/test,frams/util,frams/vm/classes,common/virtfile,frams/_demos,frams/model/geometry,frams/_demos/geometry,frams/model/similarity,frams/model/similarity/hungarian,frams/model/similarity/SVD,frams/model/similarity/EMD}
 
 GEOMETRY_OBJS=frams/model/geometry/meshbuilder.o frams/model/geometry/modelgeometryinfo.o frams/model/geometry/geometryutils.o
@@ -37,5 +37,5 @@
 NEURO_OBJS=frams/neuro/neuroimpl.o frams/neuro/neurofactory.o frams/neuro/impl/neuroimpl-simple.o frams/neuro/impl/neuroimpl-channels.o frams/neuro/impl/neuroimpl-fuzzy.o frams/neuro/impl/neuroimpl-fuzzy-f0.o
 
-SIMILARITY_OBJS=frams/model/similarity/hungarian/hungarian.o frams/model/similarity/SVD/lapack.o frams/model/similarity/SVD/matrix_tools.o frams/model/similarity/simil_match.o frams/model/similarity/simil_model.o
+SIMILARITY_OBJS=frams/_demos/geometry/geometrytestutils.o frams/model/similarity/measure-greedy.o frams/model/similarity/measure-hungarian.o frams/model/similarity/measure-distribution.o frams/model/similarity/measure-mds-based.o frams/model/similarity/simil-measure.o frams/model/similarity/hungarian/hungarian.o frams/model/similarity/SVD/lapack.o frams/model/similarity/SVD/matrix_tools.o frams/model/similarity/simil-match.o
 
 NN_LAYOUT_OBJS=frams/canvas/nn_layout_model.o frams/canvas/nn_simple_layout.o frams/canvas/nn_smart_layout.o
@@ -96,9 +96,9 @@
 SIMIL_TEST_OBJS=frams/_demos/simil_test.o $(SIMILARITY_OBJS) frams/_demos/genotypeloader.o frams/_demos/genotypemini.o frams/param/multiparamload.o common/virtfile/stdiofile.o $(STDOUT_LOGGER_OBJS) $(SDK_OBJS) $(GENOCONV_AND_GENMAN_SDK_OBJS)
 
-SIMIL_UNITTESTS_OBJS=frams/_demos/simil_unittests.o frams/model/similarity/simil_match.o
+SIMIL_UNITTESTS_OBJS=frams/_demos/simil_unittests.o frams/model/similarity/simil-match.o
 
 PARAMTREE_STDIN_TEST_OBJS=frams/_demos/paramtree_stdin_test.o frams/_demos/paramtree_print.o $(STDOUT_LOGGER_OBJS) common/virtfile/stdiofile.o $(SDK_OBJS) frams/param/paramtree.o
 
-PARAMTREE_PARAMLIST_TEST_OBJS=$(sort frams/_demos/paramtree_paramlist_test.o frams/_demos/paramtree_print.o $(STDOUT_LOGGER_OBJS) common/virtfile/stdiofile.o $(SDK_OBJS) $(GENOCONV_AND_GENMAN_SDK_OBJS) frams/neuro/neuroimpl.o frams/neuro/neurofactory.o frams/neuro/impl/neuroimpl-simple.o frams/neuro/impl/neuroimpl-channels.o frams/neuro/impl/neuroimpl-fuzzy.o frams/neuro/impl/neuroimpl-fuzzy-f0.o $(GENOTYPE_LOADER_OBJS) $(GEOMETRY_OBJS) frams/model/geometry/modelgeoclass.o frams/model/modelobj.o frams/param/paramtree.o)
+PARAMTREE_PARAMLIST_TEST_OBJS=$(sort frams/_demos/paramtree_paramlist_test.o frams/_demos/paramtree_print.o $(STDOUT_LOGGER_OBJS) common/virtfile/stdiofile.o $(SDK_OBJS) $(GENOCONV_AND_GENMAN_SDK_OBJS) frams/neuro/neuroimpl.o frams/neuro/neurofactory.o frams/neuro/impl/neuroimpl-simple.o frams/neuro/impl/neuroimpl-channels.o frams/neuro/impl/neuroimpl-fuzzy.o frams/neuro/impl/neuroimpl-fuzzy-f0.o $(GENOTYPE_LOADER_OBJS) $(GEOMETRY_OBJS) $(SIMILARITY_OBJS) frams/model/geometry/modelgeoclass.o frams/model/modelobj.o frams/param/paramtree.o)
 
 MUTABLEPARAM_TEST_OBJS=frams/_demos/mutableparam_test.o $(STDOUT_LOGGER_OBJS) common/virtfile/stdiofile.o $(SDK_OBJS) frams/param/mutableparam.o frams/param/mutparamlist.o frams/param/paramtrans.o
Index: /cpp/frams/_demos/paramtree_paramlist_test.cpp
===================================================================
--- /cpp/frams/_demos/paramtree_paramlist_test.cpp	(revision 1043)
+++ /cpp/frams/_demos/paramtree_paramlist_test.cpp	(revision 1044)
@@ -11,4 +11,7 @@
 #include <frams/model/geometry/modelgeoclass.h>
 #include <frams/model/modelobj.h>
+#include <frams/model/similarity/measure-distribution.h>
+#include <frams/model/similarity/measure-greedy.h>
+#include <frams/model/similarity/measure-hungarian.h>
 #include "genotypeloader.h"
 #include "paramtree_print.h"
@@ -27,4 +30,7 @@
 	NeuroNetConfig nn_config(&neurofac);
 	ModelGeometry modelgeo;
+	SimilMeasureDistribution simil_measure_distr;
+	SimilMeasureGreedy simil_measure_greedy;
+	SimilMeasureHungarian simil_measure_hungarian;
 
 	MutableParamList combined;
@@ -39,4 +45,7 @@
 	combined += &nn_config.par;
 	combined += &modelgeo.par;
+	combined += &simil_measure_distr.localpar;
+	combined += &simil_measure_greedy.localpar;
+	combined += &simil_measure_hungarian.localpar;
 
 	ParamTree tree(&combined);
Index: /cpp/frams/_demos/simil_test.cpp
===================================================================
--- /cpp/frams/_demos/simil_test.cpp	(revision 1043)
+++ /cpp/frams/_demos/simil_test.cpp	(revision 1044)
@@ -5,11 +5,37 @@
 
 #include <vector>
+#include <string>
 #include "common/loggers/loggertostdout.h"
 #include "frams/_demos/genotypeloader.h"
 #include "frams/genetics/preconfigured.h"
 #include "common/virtfile/stdiofile.h"
-#include "frams/model/similarity/simil_model.h"
-
-
+#include "frams/model/similarity/measure-distribution.h"
+#include "frams/model/similarity/measure-greedy.h"
+#include "frams/model/similarity/measure-hungarian.h"
+
+using namespace std;
+
+int add_double_param(std::vector<string> *args, int pos, std::vector<double> *params, std::vector<string> *params_names)
+{
+    for (unsigned int i = 0; i < params_names->size(); i++)
+    {
+        try
+        {
+            params->push_back(std::stod(args->at(pos)));
+            pos++;
+        }
+        catch (const std::invalid_argument&)
+        {
+            printf("%s should be a number\n", params_names->at(i).c_str());
+            return -1;
+        }
+        catch (const std::out_of_range&)
+        {
+            printf("%s should be inside double range\n", params_names->at(i).c_str());
+            return -1;
+        }
+    }
+    return 0;
+}
 
 /** Computes a matrix of distances between all genotypes in the specified
@@ -18,206 +44,181 @@
 int main(int argc, char *argv[])
 {
-	LoggerToStdout messages_to_stdout(LoggerBase::Enable);
-	int iCurrParam = 0; // index of the currently processed parameter
-	char *szCurrParam = NULL;
-	ModelSimil M; // similarity computing object
-	bool bPrintNames = false; // specifies if names of genotypes are to be printed
-	int nResult = 0; // a temporary result
-
-	if (argc < 8)
-	{
-		printf("Too few parameters!\n");
-		printf("Command line: [-names] <genotypesFile> <measure> <w_dP> <w_dDEG> <w_dNEU> <w_dGEO> <fixZaxis?>\n\n");
-
-		printf("Parameters:\n");
-		printf("  <genotypesFile> name of a file with genotypes\n");
-		printf("  <measure> similarity measure\n");
-		printf("  <w_dP> weight of the difference in the number of parts\n");
-		printf("  <w_dDEG> weight of the difference in degrees of matched parts\n");
-		printf("  <w_dNEU> weight of the difference in neurons of matched parts\n");
-		printf("  <w_dGEO> weight of the distance of matched parts\n");
-		printf("  <fixZaxis?> should the 'z' (vertical) coordinate be fixed during the alignment? (0 or 1)\n\n");
-
-		printf("Switches:\n");
-		printf("  -names specifies that the number and names of genotypes are to be printed to output\n");
-		printf("  before the distance matrix; by default the number and names are not printed\n\n");
-
-		printf("Outputs a symmetric distance matrix in the format:\n");
-		printf("  <row_1> (columns in a row are separated by TABs)\n");
-		printf("  ...\n");
-		printf("  <row_n>\n");
-
-		return -1;
-	}
-
-	// prepare output parameters from .gen file
-	vector<Geno *> pvGenos;
-	vector<char *> pvNames;
-
-	// check if there is a switch
-	iCurrParam = 1;
-	szCurrParam = argv[iCurrParam];
-	if (strcmp(szCurrParam, "-names") == 0)
-	{
-		// switch "-names" was given; print names also
-		bPrintNames = true;
-		// pass to the next parameter
-		iCurrParam++;
-	}
-
-	// check the parameters
-	// get <genotypesFile> name from command line
-	char *szFileName = argv[iCurrParam];
-
-	// initially set measure components' weights to invalid values (negative)
-	for (int i = 0; i < M.GetNOFactors(); i++)
-	{
-		M.m_adFactors[i] = -1.0;
-	}
-
-	iCurrParam++;
-	szCurrParam = argv[iCurrParam];
-	int measure_type = -1;
-	nResult = sscanf(szCurrParam, "%d", &measure_type);
-	if (nResult != 1)
-	{
-		printf("Measure type should be a number!\n");
-		return -1;
-	}
-
-	if (measure_type != 0 && measure_type != 1)
-	{
-		printf("Measure type should be 0 (flexible criteria order and optimal matching) or 1 (vertex degree order and greedy matching)!\n");
-		return -1;
-	}
-
-	M.matching_method = measure_type;
-
-	const char *params[] = { "<w_dP>", "<w_dDEG>", "<w_dNEU>", "<w_dGEO>" };
-	for (int i = 0; i < M.GetNOFactors(); i++)
-	{
-		iCurrParam++;
-		szCurrParam = argv[iCurrParam];
-		nResult = sscanf(szCurrParam, "%lf", &M.m_adFactors[i]);
-		if (nResult != 1)
-		{
-			// <w_dX> is not a number -- error
-			printf("%s", params[i]);
-			printf(" should be a number\n");
-			return -1;
-		}
-		else
-		{
-			// <w_dX> is a number; check if nonnegative
-			if (M.m_adFactors[i] < 0.0)
-			{
-				printf("%s", params[i]);
-				printf(" should be a nonnegative number\n");
-				return -1;
-			}
-		}
-	}
-
-	iCurrParam++;
-	szCurrParam = argv[iCurrParam];
-	nResult = sscanf(szCurrParam, "%d", &M.fixedZaxis);
-	if (nResult != 1)
-	{
-		// <isZFixed> is not a number -- error
-		printf("<isZFixed> should be a number\n");
-		return -1;
-	}
-	else if (M.fixedZaxis != 0 && M.fixedZaxis != 1)
-	{
-		printf("<isZFixed>=%d. <isZFixed> should be equal to 0 or 1\n", M.fixedZaxis);
-		return -1;
-	}
-
-	// read the input file
-	// prepare loading of genotypes from a .gen file
-	// create some basic genotype converters
-	PreconfiguredGenetics genetics;
-	StdioFileSystem_autoselect stdiofilesys;
-
-	long count = 0, totalsize = 0;
-	GenotypeMiniLoader loader(szFileName);
-	GenotypeMini *loaded;
-	while (loaded = loader.loadNextGenotype())
-	{
-		// while a valid genotype was loaded
-		count++;
-		totalsize += loaded->genotype.length();
-		// create a Geno object based on the MiniGenotype
-		Geno *pNextGenotype = new Geno(loaded->genotype);
-		if ((pNextGenotype != NULL) && (pNextGenotype->isValid()))
-		{
-			pvGenos.push_back(pNextGenotype);
-			char *szNewName = new char[loaded->name.length() + 1];
-			strcpy(szNewName, loaded->name.c_str());
-			pvNames.push_back(szNewName);
-		}
-		else
-		{
-			printf("Genotype %2li is not valid\n", count);
-			if (pNextGenotype != NULL) delete pNextGenotype;
-		}
-	}
-	if (loader.getStatus() == GenotypeMiniLoader::OnError)
-	{
-		printf("Error: %s", loader.getError().c_str());
-	}
-
-	double dSimilarity = 0.0;
-	double **aaSimil = NULL; // array of similarities
-
-	// create an empty array of similarities
-	aaSimil = new double*[pvGenos.size()];
-	for (unsigned int k = 0; k < pvGenos.size(); k++)
-	{
-		aaSimil[k] = new double[pvGenos.size()];
-		for (unsigned int l = 0; l < pvGenos.size(); l++)
-			aaSimil[k][l] = 0.0;
-	}
-
-	// compute and store similarities
-	for (unsigned int i = 0; i < pvGenos.size(); i++)
-	{
-		for (unsigned int j = 0; j < pvGenos.size(); j++)
-		{
-			dSimilarity = M.EvaluateDistance(pvGenos.operator[](i), pvGenos.operator[](j));
-			aaSimil[i][j] = dSimilarity;
-		}
-	}
-
-	if (bPrintNames)
-	{
-		// if the "-names" switch was given, print the number of genotypes and their names
-		printf("%li\n", pvGenos.size());
-		for (unsigned int iGen = 0; iGen < pvNames.size(); iGen++)
-		{
-			printf("%s\n", pvNames.at(iGen));
-		}
-	}
-
-	// print out the matrix of similarities
-	for (unsigned int i = 0; i < pvGenos.size(); i++)
-	{
-		for (unsigned int j = 0; j < pvGenos.size(); j++)
-		{
-			printf("%.2lf\t", aaSimil[i][j]);
-		}
-		printf("\n");
-	}
-
-	// delete vectors and arrays
-	for (unsigned int i = 0; i < pvGenos.size(); i++)
-	{
-		delete pvGenos.operator[](i);
-		delete[] pvNames.operator[](i);
-		delete[] aaSimil[i];
-	}
-
-	delete[] aaSimil;
-
-	return 0;
+    typedef double *pDouble;
+    LoggerToStdout messages_to_stdout(LoggerBase::Enable);
+    SimilMeasure *simil_measure = nullptr;
+    if (argc < 5)
+    {
+        printf("Too few parameters!\n");
+        printf("Command line: [-names] <genotypesFile> <measure (greedy/hungarian)> <w_dP> <w_dDEG> <w_dNEU> <w_dGEO> <fixZaxis?>\n\n");
+        printf("Command line: [-names] <genotypesFile> <measure (distribution)> <desc> <simil> <dens> <bins> <samp_num>\n\n");
+        printf("Parameters:\n");
+        printf("  <genotypesFile> name of a file with genotypes\n");
+        printf("  <measure> similarity measure name (greedy/hungarian/distribution)\n");
+        printf("\n");
+        printf("Parameters of greedy and hungarian measures:\n");
+        printf("  <w_dP> weight of the difference in the number of parts\n");
+        printf("  <w_dDEG> weight of the difference in degrees of matched parts\n");
+        printf("  <w_dNEU> weight of the difference in neurons of matched parts\n");
+        printf("  <w_dGEO> weight of the distance of matched parts\n");
+        printf("  <fixZaxis?> should the 'z' (vertical) coordinate be fixed during the alignment? (0 or 1)\n\n");
+        printf("Parameters of distribution measure:\n");
+        printf("  <dens> sampling density\n");
+        printf("  <bins> number of histogram bins\n");
+        printf("  <samp_num> number of samples taken\n\n");
+
+        printf("Switches:\n");
+        printf("  -names specifies that the number and names of genotypes are to be printed to output\n");
+        printf("  before the distance matrix; by default the number and names are not printed\n\n");
+
+        printf("Outputs a symmetric distance matrix in the format:\n");
+        printf("  <row_1> (columns in a row are separated by TABs)\n");
+        printf("  ...\n");
+        printf("  <row_n>\n");
+
+        return -1;
+    }
+
+    std::vector<string> args;
+    for (int i = 1; i < argc; i++)
+        args.push_back(std::string(argv[i]));
+
+    bool print_names = false;
+
+    int pos = 1;
+    if (args.at(0).compare("-names")==0)
+    {
+        print_names = true;
+        pos = 2;
+    }
+
+    string measure_name = args.at(pos);
+    pos++;
+    std::vector<double> params;
+
+    if (measure_name.compare("greedy")==0 || measure_name.compare("hungarian")==0)
+    {
+        std::vector<string> params_names{ "<w_dP>", "<w_dDEG>", "<w_dNEU>", "<w_dGEO>",  "<fixZaxis?>" };
+
+        if (add_double_param(&args, pos, &params, &params_names) == -1)
+            return -1;
+
+        if (measure_name.compare("greedy")==0)
+            simil_measure = new SimilMeasureGreedy();
+        else
+            simil_measure = new SimilMeasureHungarian();
+    }
+
+
+    else if (measure_name.compare("distribution")==0)
+    {
+        std::vector<string> params_names{ "<dens>", "<bins>", "<samp_num>" };
+
+        if (add_double_param(&args, pos, &params, &params_names)==-1)
+            return -1;
+
+        simil_measure = new SimilMeasureDistribution();
+    }
+
+    else
+    {
+        printf("Measure type should be greedy (flexible criteria order and optimal matching), hungarian (vertex degree order and greedy matching) or distribution!\n");
+        return -1;
+    }
+
+    simil_measure->setParams(params);
+
+    // read the input file
+    // prepare loading of genotypes from a .gen file
+    // create some basic genotype converters
+    PreconfiguredGenetics genetics;
+    StdioFileSystem_autoselect stdiofilesys;
+
+    // prepare output parameters from .gen file
+    vector<Geno *> pvGenos;
+    vector<char *> pvNames;
+
+    long count = 0, totalsize = 0;
+    GenotypeMiniLoader loader(args.at(0).c_str());
+    GenotypeMini *loaded;
+    while (loaded = loader.loadNextGenotype())
+    {
+        // while a valid genotype was loaded
+        count++;
+        totalsize += loaded->genotype.length();
+        // create a Geno object based on the MiniGenotype
+        Geno *pNextGenotype = new Geno(loaded->genotype);
+        if ((pNextGenotype != NULL) && (pNextGenotype->isValid()))
+        {
+            pvGenos.push_back(pNextGenotype);
+            char *szNewName = new char[loaded->name.length() + 1];
+            strcpy(szNewName, loaded->name.c_str());
+            pvNames.push_back(szNewName);
+        }
+        else
+        {
+            printf("Genotype %2li is not valid\n", count);
+            if (pNextGenotype != NULL) delete pNextGenotype;
+        }
+    }
+    if (loader.getStatus() == GenotypeMiniLoader::OnError)
+    {
+        printf("Error: %s", loader.getError().c_str());
+    }
+
+    double dSimilarity = 0.0;
+    double **aaSimil = NULL; // array of similarities
+
+    // create the empty array of similarities
+    aaSimil = new pDouble[pvGenos.size()];
+    for (unsigned int k = 0; k < pvGenos.size(); k++)
+    {
+        aaSimil[k] = new double[pvGenos.size()];
+        for (unsigned int l = 0; l < pvGenos.size(); l++)
+            aaSimil[k][l] = 0.0;
+    }
+
+
+
+    // compute and remember similarities
+    for (unsigned int i = 0; i < pvGenos.size(); i++)
+    {
+        for (unsigned int j = 0; j < pvGenos.size(); j++)
+        {
+            dSimilarity = simil_measure->evaluateDistance(pvGenos.operator[](i), pvGenos.operator[](j));
+            aaSimil[i][j] = dSimilarity;
+        }
+    }
+
+    if (print_names)
+    {
+        // if "-names" switch was given, print the number of genotypes and their names
+        printf("%li\n", pvGenos.size());
+        for (unsigned int iGen = 0; iGen < pvNames.size(); iGen++)
+        {
+            printf("%s\n", pvNames.at(iGen));
+        }
+    }
+
+    // print out the matrix of similarities
+    for (unsigned int i = 0; i < pvGenos.size(); i++)
+    {
+        for (unsigned int j = 0; j < pvGenos.size(); j++)
+        {
+            printf("%.2lf\t", aaSimil[i][j]);
+        }
+        printf("\n");
+    }
+
+    // delete vectors and arrays
+    for (unsigned int i = 0; i < pvGenos.size(); i++)
+    {
+        delete pvGenos.operator[](i);
+        delete[] pvNames.operator[](i);
+        delete[] aaSimil[i];
+    }
+
+    delete[] aaSimil;
+    delete simil_measure;
+
+    return 0;
 }
